## -*- coding: utf-8 -*-
## Copyright (C)200x Ingeniweb - all rights reserved
## No publication or distribution without authorization.

## Script (Python) "booking_workflow_notification"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=notified_obj
##title=Workflow notification
##

from Products.CMFCore.utils import getToolByName

# Get review state
wf_tool = getToolByName(context, 'portal_workflow')
obj_review_state = wf_tool.getInfoFor(notified_obj, 'review_state')

mship = context.portal_membership

try:
    mhost = context.MailHost
except:
    # no mailhost found
    mhost = None

# the message format, %s will be filled in from data
message_template = """
From: %s
To: %s
Subject: %s - %s

%s

URL: %s
"""


if mhost:

    if 'booked' == obj_review_state:
        # object has been booked, contact the user
        receiver = notified_obj.getEmail()
        sender = context.email_from_address
        subject = 'Booking confirmation'
        body = 'Your booking from %s to %s has been confirmed.'
        body = body % (notified_obj.getStartDate(), notified_obj.getEndDate())
    else:
        #elif 'pending' == obj_review_state:
        # a booking is pending, contact the admin
        receiver = context.email_from_address
        sender = notified_obj.getEmail()
        subject = 'New booking pending'
        body = 'A booking is pending.'

    msg = message_template % (
             sender,
             receiver,
             subject,
             notified_obj.TitleOrId(),
             body,
             notified_obj.absolute_url()
          )
    try:
        mhost.send(msg)
    except:
        # send mail failed
        pass
